library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity pll is
    Port ( PLLCLK : in  STD_LOGIC;
			REFCLK : in  STD_LOGIC;
			PLLCTRL : inout  STD_LOGIC
		  );
end pll;

architecture RTL of pll is
		signal up : std_logic := '0';  -- 
		signal down : std_logic:= '0'; -- 
		signal up_out : std_logic;     -- 
		signal down_out : std_logic;   -- 

begin
	PLLCTRL <= '1' when (up_out = '0') else '0' when (down_out = '0') else 'Z';

	down_out <= ( not down or up );
	up_out <= ( not up or down );

	process (PLLCLK,REFCLK)
	begin
		if (down = '1' and up = '1') then
			up <= '0';
			down <= '0';
		else
			if (PLLCLK' event and PLLCLK = '1') then
				down <= '1';
			end if;
			if (REFCLK' event and REFCLK = '1') then
				up <= '1';
			end if;
		end if;
	end process;

end RTL;


